namespace MyTM
{
 public class MyTM : System.MarshalByRefObject, TP.TM
{
	public MyTM()
	{
		System.Console.WriteLine( "Transaction Manager instantiated" );
	}

	class Transaction : TP.Transaction
	{
	}

	public TP.Transaction Start()
	{
		Transaction context = new Transaction();
		System.Console.WriteLine( string.Format( "Transaction {0} started", context.Id ));
		return context;
	}

	public void Commit( TP.Transaction context )
	{
		System.Console.WriteLine( string.Format( "Transaction {0} commited", context.Id ));
	}

	public void Abort( TP.Transaction context )
	{
		System.Console.WriteLine( string.Format( "Transaction {0} aborted", context.Id ));
	}

	public void Enlist( TP.Transaction context )
	{
		System.Console.WriteLine( string.Format( "Transaction {0} enlisted", context.Id ));
	}

	static void Main( string [] args )
	{
		System.Runtime.Remoting.Channels.HTTP.HTTPChannel channel = new System.Runtime.Remoting.Channels.HTTP.HTTPChannel( 8081 );
		System.Runtime.Remoting.ChannelServices.RegisterChannel( channel );
        System.Runtime.Remoting.RemotingServices.RegisterWellKnownType
		(	"MyTM"							// assembly name
		,	"MyTM.MyTM"						// full type name
	        ,	"TM.soap"						// URI
		,	System.Runtime.Remoting.WellKnownObjectMode.Singleton	// instancing mode
		);
		while( true )
			System.Threading.Thread.Sleep( 100000 );
	}
}
}
